 #include <string.h>
//------------------------------------------------------44-01.cpp
 #include <fstream.h>
 #define FNULL -1L
 typedef int BOOL;
 typedef long FPTR;                         //  -   
 typedef unsigned char _FAR *BUF;            //  -  
 class BinFile : public fstream{
 public:
 BOOL Create(char *);                           //   
 BOOL Open(char *);                            //  
 FPTR Size()                                 //    
 { seekg(0L,ios::end);                         //  
      return(tellg()); }                                //  
 void *VSZLoad(int&);                          //    
 FPTR VSZAppend(void*,int);               //   
 FPTR VSZUpdate(void*,int,int);                                    //
      BinFile() { fstream(); }                                      //
      ~BinFile() { close();}                                        //
 };
 //--------  "  "   
 BOOL BinFile::Create(char *s){
 int a=1;
 open(s, ios::trunc | ios::out | ios::binary );
      if (good()) { close(); return 1; }
 return 0; }
 //------        /
 BOOL BinFile::Open(char * s){
 open(s,ios::in | ios::out | ios::binary);
 return good(); }
//------------------------------------------------------44-02.cpp
 void *BinFile::VSZLoad(int &sz){
 char *pdata;
 read((BUF)&sz, sizeof(int));
 if (!good()) return NULL;
 if ((pdata = new char[sz])==NULL ) return NULL;
 read((unsigned char *)pdata,sz);
 if (good()) return (void *)pdata;
 delete pdata;
 return NULL; }
//------------------------------------------------------44-03.cpp
 FPTR BinFile::VSZUpdate(void *buf ,int sz, int mode) {
 int oldsz;
 FPTR pos;
 pos = tellg();
      if (mode){
      read((BUF)&oldsz,sizeof(int));
      if (!good()) return(FNULL);
      if (oldsz < sz) return VSZAppend(buf,sz);
      seekg(pos);
      if (!good()) return FNULL;
      }
 write((BUF)&sz,sizeof(int));
 write((BUF)buf,sz);
 if (!good()) return FNULL;
 return pos; }

 FPTR BinFile::VSZAppend(void *buf ,int sz){
 FPTR pos;
 if ((pos = Size()) ==FNULL) return FNULL;
 write((BUF)&sz,sizeof(int));
 write((BUF)buf,sz);
 if (!good()) return FNULL;
 return pos; }
//------------------------------------------------------44-04.cpp
 class MyFile : public BinFile {
 public:
      virtual int OnError(char *s) {
      cout << "     " << s << endl;
      cout << "   (CR-):" ;
      cin .getline(s ,80);
      return s[0]==0;
      }};
//------------------------------------------------------44-05.cpp
//----       
 class ADT {
 public:
 virtual int Get(char *)=0;              //    
 virtual char *Put()=0;                   //    
 virtual long Append(BinFile&)=0;   //     
 virtual int Load(BinFile&)=0;                                     // 
 virtual int Type()=0;                    //   
                                                       //  
 virtual char *Name()=0;                //    
 virtual int Cmp(ADT *)=0;             //   
 virtual ADT *Copy()=0;               //    -
					//    ()
      virtual ~ADT(){ };                     //  
 };
//------------------------------------------------------44-06.cpp
//------------------------------------------------------------------------------
 #define STR_TYPE 1                 //    - 
 class string : public ADT {
 char *str;
      void load(char *s) { str=new char[strlen(s)+1]; strcpy(str,s); }
 public:
	 string(char *);
	 string();
 virtual int Get(char *);
 virtual char *Put();
 virtual FPTR Append(BinFile&);
 virtual int Load(BinFile &);
 virtual int Type();
 virtual char *Name();
 virtual int Cmp(ADT *);
 virtual ADT *Copy();
 };
 
 int string::Get(char *s) { delete str; load(s); }
 char *string::Put()
 { char *p =new char[strlen(str)+1];
 strcpy(p,str); return p; }
 
 FPTR string::Append(BinFile &F)
 { return F.VSZAppend(str,strlen(str)+1); }
 int string::Load(BinFile &F)
 { int n; delete str;
 if ((str=(char*)F.VSZLoad(n))==NULL)
      { load("File Error"); return 0; }
 return 1; }
 
 int string::Type() { return 1; } 
 char *string::Name() { return "String"; }
 int string::Cmp(ADT *s) { return strcmp(str,((string*)s)->str); } 
 ADT *string::Copy() { string *p=new string(str); return (ADT*)p; }
//------------------------------------------------------44-07.cpp
//-----  -      
// #include "ADT.h"
 class MU {
 int sz;                                    //   
 ADT **p;                      //    ADT*
 public:
 Append(ADT*);                       //    
 ADT *min();                                     //  
 void sort();                                            // 
 int test();                //     
 int save(char *);
 int load(char *);
 MU(int);                                                           //
 ~MU();                                                             //
 };
 int MU::test() {                 //    
 for (int i=1; p[i]!=NULL; i++)
      if ( p[i]->Type() != p[i-1]->Type()) return 0;
 return 1; }
 
 ADT *MU::min() 
 { ADT *pmin; int i;
 if (p[0]==NULL || !test()) return NULL;
 for (i=0, pmin=p[0]; p[i]!=NULL; i++)
      if ( pmin->Cmp(p[i]) > 0) pmin=p[i];
 return pmin; }

 void MU::sort()
 { int d,i; ADT *q;
 if (p[0]==NULL || !test()) return;
      do {
      for (d=0, i=1; p[i]!=NULL; i++)
	   if ( p[i-1]->Cmp(p[i] ) > 0)
	   {d++; q=p[i-1]; p[i-1]=p[i]; p[i]=q; }
      } while (d!=0);}
//------------------------------------------------------44-08.cpp
//---       
 MU::~MU(){
 for (int i=0; p[i]!=NULL; i++)
      delete p[i];      //      
 delete p; }                           //   
//------------------------------------------------------44-09.cpp
 int MU::save(char *s){
 BinFile F;
 if (!F.Create(s)) return 0;           //    
 if (!F.Open(s)) return 0;                              //  
      for ( int i=0; p[i]!=NULL; i++){ //    
      int t= p[i]->Type();             //   
      F.write((BUF)&t,sizeof(int));     //     
           if (!F.good()) { F.close(); return 0; }
      if ( p[i]->Append(F)==FNULL) 	//     
           { F.close(); return 0; }
      }
 int t=0;                            //     0
 F.write((BUF)&t,sizeof(int));
 return 1; }
//------------------------------------------------------44-10.cpp
 int MU::load(char *s){
 BinFile F; ADT *q;
 if (!F.Open(s)) return 0;
      while (1) {
      int t;
      F.read((BUF)&t,sizeof(int));
           if (!F.good()) { F.close(); return 0; }
           switch (t) { //   !!!!!!!!!!!!!!!!!!!!!!! 
                     //       
      case 0: F.close(); return 1;
      case STR_TYPE: q =(ADT*) new string; break;
//    case DATE_TYPE: q =(ADT*) new date; break;
      default: F.close(); return 0;
           }
      q->Load(F);                      //   
      Append(q);                        //    
      }
 return 1; } 
