#include <stdio.h>
#include <time.h>
#include <conio.h>
//---   -      
template <class T> class FIFO
{	FIFO<T> *next;		//     
	T *data;			//    
public:
	FIFO() { next=NULL; }
	~FIFO();
	void   In(T*);		//  
	T 	*Out();		//  
	void	Remove(T*);	//    
	T	*operator[](int);	//   . 
};

template <class T> FIFO<T>::~FIFO(){
if (next!=NULL) delete next;
}

template <class T> void FIFO<T>::In(T *pdata){
FIFO<T> *p, *pn=new FIFO<T>;
pn->data=pdata; pn->next=NULL;
for (p=this; p->next!=NULL; p=p->next);
p->next=pn;
}

template <class T> T *FIFO<T>::Out(){
FIFO<T> *p=next;
if (p==NULL) return NULL;
T *pdata=p->data;
next = p->next;
p->next=NULL;
delete p;
return pdata;
}

template <class T> T *FIFO<T>::operator[](int n){
FIFO<T> *p;
for (p=next; p!=NULL && n!=0; p=p->next, n--);
if (p==NULL) return NULL;
return p->data;
}

template <class T> void FIFO<T>::Remove(T *pdata){
FIFO<T> *p;
for (p=this; p->next!=NULL; p=p->next)
	if (p->next->data==pdata){
		FIFO<T> *q=p->next;
		p->next=q->next;
		q->next=NULL;
		delete q;
		return;
		}
}
//---   -----------------------------------
#define	ms_NULL	0	//  
#define ms_KEYB	1	//  
#define	ms_TICK	2	//  
#define ms_ECHO	5	//    this
#define ms_EXIT	6	//  
#define ms_KILL	7	//  
#define	ms_BORN	8	//  

class MS {
public:
char	code;		//  
int	x,y;		//  
	void	*p;		//   
MS(char,int,int,void *);//  -  
	~MS();
void	clear() { code=ms_NULL; };	// "" 
};

MS::MS(char c,int xx,int yy,void *q) { code = c; x = xx; y = yy; p = q; }
MS::~MS() {}
//---  ,   -----------
class	OBJ {
friend class PRG;			//   
static 	PRG	*programm;		//  () 
public:					//   - 
	void	SendEvent(char,int,int,void *);
virtual	void	HandleEvent(MS *);	//  
		OBJ();			// 
virtual	~OBJ();				// 
};

PRG	*OBJ::programm = NULL;
//-----   
class PRG {
	FIFO<OBJ>	objects;  	//  
	FIFO<MS>	messages; 	//  
public:
	PRG();
	~PRG();
	void	SendEvent(char,int,int,void *);
	void	run(); };

void	OBJ::SendEvent(char code0, int x0, int y0, void *p0)
{ if (programm !=NULL) programm->SendEvent(code0,x0,y0,p0);}

void	OBJ::HandleEvent(MS *pm) { pm->clear(); }

OBJ::OBJ() { SendEvent(ms_BORN,0,0,this); }

OBJ::~OBJ() {}

//---  :    OBJ
PRG::PRG() { OBJ::programm = this; }
//----      -------------------
void	PRG::SendEvent(char code0,int x0,int y0, void *p0)
{ messages.In(new MS(code0,x0,y0,p0)); }

//------    
void	PRG::run()
{ MS *pm; OBJ *pp;
clock_t t;
t = clock();
while(1){
for (int n=0; (pm = messages.Out()) !=NULL; n++){
	switch (pm->code)	//      -
		{		//   
case ms_BORN:			//    
		objects.In((OBJ*)pm->p);	//  -    
		break;
case ms_NULL:	break;		//  
case ms_EXIT:	return;		//    
case ms_KILL:			//     -
		pp = (OBJ*)pm->p;//  ,  
				//  
		objects.Remove(pp);//    
		delete pp;	//    -
		break;		//   
default:			//   
				//    
	for (int m=0; (pp = objects[m])!=NULL; m++)
		{		//    
		pp->HandleEvent(pm);
				//    
		if (pm->code == ms_NULL) break;
	}}
	delete pm;		//  
	}
//-----    ---------------------
if (kbhit()){			//   
messages.In(new MS(ms_KEYB,(int)getch(),0,NULL));
}
if ( clock()-t > 1)		//    ()
	{ t = clock();
messages.In(new MS(ms_TICK,0,0,NULL));
	}
}}
// :     -------------
PRG::~PRG() {
MS *p;
OBJ *q;
while ((p=messages.Out())!=NULL) delete p;
while ((q=objects.Out())  !=NULL) delete q;
}
//-----    
class   MOUSE : public OBJ {};
class	myPRG : public PRG{
public:
myPRG() { MOUSE *pms = new MOUSE; }
};
void	main(){
myPRG myprog;
myprog.run();
}
