#include <iostream.h>
#include <string.h>
class string
	{
	char *str;
	void load(char *s) { str=new char[strlen(s)+1]; strcpy(str,s); }
	void add(char *);
	int find(char *);
	int cmp(string &t) { return strcmp(str,t.str); }

public:
	string() { load(""); }
	string(char *s) { load(s);  }
	string(string &t) { load(t.str); }
	~string() { delete str; }
	friend void operator<<(char *s, string &R) {strcpy(s,R.str); }

	friend ostream &operator<<(ostream& IO, string &t)
		{ IO << t.str; return IO; }

	friend istream &operator>>(istream &, string &);

	string operator+(char *s)
		{ string x(str); x.add(s); return x; }

	string operator+(char s)
		{ char c[2]; c[0]=s; c[1]=0; string x(str); x.add(c); return x; }

	string operator+(string &t)
		{ return *this + t.str; }

	friend string operator+(char *s, string &t)
		{ string x(s); x.add(t.str); return x; }

	int operator[](char *s) { return find(s); }
	char operator[](int n) { if (n>=strlen(str)) return 0; else return str[n]; }
	operator int() { return strlen(str); }

	string operator()(int,int);

	string operator-(char *s);

	string operator-(string &t) { return *this-t.str; }

	string &operator=(string &r)
		{ this->~string(); load(r.str); return *this; }

	string &operator=(char *s)
		{ this->~string(); load(s); return *this; }

	int operator==(string &t) { return cmp(t)==0; }
	int operator!=(string &t) { return cmp(t)!=0; }
	int operator< (string &t) { return cmp(t)< 0; }
	int operator<=(string &t) { return cmp(t)<=0; }
	int operator> (string &t) { return cmp(t)> 0; }
	int operator>=(string &t) { return cmp(t)>=0; }
	};

istream &operator>>(istream& IO, string &t)
		{ char s[80]; IO >> s; t=s; return IO; }

void string::add(char *s)
		{ char *ss=new char[strlen(str)+strlen(s)+1];
			strcpy(ss,str); strcat(ss,s); delete str; str=ss;
		}

int string::find(char *s)
		{
      int i;
		for (int k=0; str[k]!=0; k++)
			{
			for (i=0; str[k+i]!=0 && s[i]!=0 && s[i]==str[k+i]; i++);
			if (s[i]==0) return k;
			}
		return -1;
		}

string string::operator()(int n1, int n2=-1)
	{
	if (n2==-1) n2=strlen(str);
	if (n1<0 || n2<0 || n1>strlen(str) || n2>strlen(str) || n1>n2)
		{ string x("???"); return x; }
	char c=str[n2]; str[n2]=0;
	string x(str+n1);
	str[n2]=c;
	return x;
	}

string string::operator-(char *s)
		{
		int n=find(s);
		if (n<0) return *this;
		return (*this)(0,n)+(*this)(n+strlen(s));
		}

