#include "zlist.h"
#include "string.h"	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#include "polu.h"		//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

zlist::zlist()
{ prev=next=this; }

zlist::~zlist()
{
while (next!=this)
	{ remove(0); }
}

zlist *zlist::find(int n=-1)
{
zlist *p;
for (p=next; n!=0 && p!=this; n--, p=p->next);
return p;
}

ADT *zlist::operator[](int n=-1)
{
if (n==-1) n=size()-1;
zlist *p=find(n);
if (p==this) return NULL; else return p->data;
}

int zlist::size()
{
int n;
zlist *p;
for (n=0, p=next; p!=this; n++, p=p->next);
return n;
}

ADT *zlist::remove(int n=-1)
{
if (n==-1) n=size()-1;
zlist *p=find(n);
if (p==this) return NULL;
ADT *s=p->data;
p->prev->next=p->next;
p->next->prev=p->prev;
p->next=p->prev=p;
delete p;
}

int zlist::operator()(ADT *s,int n=-1)
{
zlist *p=find(n);
zlist *q=new zlist;
q->data=s;
q->next=p;
q->prev=p->prev;
p->prev->next=q;
p->prev=q;
return 1;
}

ADT *zlist::min()
{
if (next==this) return NULL;
zlist *pmin=next;
for (zlist *q=next; q!=this; q=q->next)
	{
    if (pmin->data->Cmp(q->data) > 0) pmin=q;
    }
return pmin->data;
}

void zlist::clear(int mode)
{
ADT *p;
while ((p=remove(0))!=NULL) if (mode) delete p;
}

int	zlist::save(char *s)
{
BinFile F;
if (!F.Create(s)) return 0;
if (!F.Open(s)) return 0;
zlist *p;
for (p=next; p!=this; p=p->next)
	{
	int t=p->data->Type();
	F.write((BUF)&t,sizeof(int));
	if (!F.good()) { F.close(); return 0; }
	if (p->data->Append(F)==FNULL)  { F.close(); return 0; }
	}
int t=0;
F.write((BUF)&t,sizeof(int));
return 1;
}

int	zlist::load(char *s)
{
BinFile F;
ADT *q;
if (!F.Open(s)) return 0;
while (1)
	{
	int t;
	F.read((BUF)&t,sizeof(int));
	if (!F.good()) { F.close(); return 0; }
    switch (t)  	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    	{
case 0:	F.close(); return 1;
case 1: q =(ADT*) new string; break;
case 2: q =(ADT*) new polu; break;
default:F.close(); return 0;
		}
    q->Load(F);
    (*this)(q);
	}
return 1;
}
